package com.dgtly.system.service;

import com.dgtly.system.domain.AlertUpvoteLog;
import java.util.List;

/**
 * 弹框点赞日志Service接口
 * 
 * @author dgtlc
 * @date 2024-12-24
 */
public interface IAlertUpvoteLogService 
{
    /**
     * 查询弹框点赞日志
     * 
     * @param alertUpvoteId 弹框点赞日志ID
     * @return 弹框点赞日志
     */
    public AlertUpvoteLog selectAlertUpvoteLogById(Long alertUpvoteId);

    /**
     * 查询弹框点赞日志列表
     * 
     * @param alertUpvoteLog 弹框点赞日志
     * @return 弹框点赞日志集合
     */
    public List<AlertUpvoteLog> selectAlertUpvoteLogList(AlertUpvoteLog alertUpvoteLog);

    /**
     * 新增弹框点赞日志
     * 
     * @param alertUpvoteLog 弹框点赞日志
     * @return 结果
     */
    public int insertAlertUpvoteLog(AlertUpvoteLog alertUpvoteLog);

    /**
     * 修改弹框点赞日志
     * 
     * @param alertUpvoteLog 弹框点赞日志
     * @return 结果
     */
    public int updateAlertUpvoteLog(AlertUpvoteLog alertUpvoteLog);

    /**
     * 批量删除弹框点赞日志
     * 
     * @param ids 需要删除的数据ID
     * @return 结果
     */
    public int deleteAlertUpvoteLogByIds(String ids);

    /**
     * 删除弹框点赞日志信息
     * 
     * @param alertUpvoteId 弹框点赞日志ID
     * @return 结果
     */
    public int deleteAlertUpvoteLogById(Long alertUpvoteId);

    /**
    * @description: 根据用户ID、弹框ID查询是否有记录
    * @param userId 用户ID
	* @param alertId 弹框ID
    * @return com.dgtly.system.domain.AlertUpvoteLog
    * @author lc
    * @date 2024-12-25 11:12
    */
    public AlertUpvoteLog selectUpvoteByUidAndAid(Long userId,Long alertId);
}
